---

 source/nc.c            |  112 +++++++++++++++++++++++++++++++++++++++----------
 source/server.c        |   42 +++++++++++-------
 source/server_common.c |   16 +++----
 source/windowTitle.c   |    8 ++-
 util/utils.c           |  101 +++++++++++++++++++++++++++++---------------
 util/utils.h           |    6 +-
 6 files changed, 202 insertions(+), 83 deletions(-)

diff --quilt old/source/nc.c new/source/nc.c
--- old/source/nc.c
+++ new/source/nc.c
@@ -181,7 +181,7 @@ static void setPropertyValue(Atom atom) 
 }
 
 /* Add another entry to the file entry list, if it doesn't exist yet. */
-static void addToFileList(const char *path)
+static void addToFileList(long prefixLen, const char *prefix, const char *path)
 {
     FileListEntry *item;
     
@@ -196,8 +196,9 @@ static void addToFileList(const char *pa
         item = malloc(sizeof(item[0]));
         item->waitForFileOpenAtom = None;
         item->waitForFileClosedAtom = None;
-        item->path = (char*)malloc(strlen(path)+1);
-        strcpy(item->path, path);
+        item->path = (char*)malloc(prefixLen+strlen(path)+1);
+        strcpy(item->path, prefix);
+        strcpy(item->path + prefixLen, path);
         item->next = fileListHead.fileList;
         fileListHead.fileList = item;
     }
@@ -233,6 +234,8 @@ int main(int argc, char **argv)
     Atom serverExistsAtom, serverRequestAtom;
     XrmDatabase prefDB;
     Boolean serverExists;
+    int xt_argc;
+    char **xt_argv;
 
     /* Initialize toolkit and get an application context */
     XtToolkitInitialize();
@@ -251,21 +254,26 @@ int main(int argc, char **argv)
        don't support the .nc file anymore) */
     prefDB = CreatePreferencesDatabase(NULL, APP_CLASS, 
 	    OpTable, XtNumber(OpTable), (unsigned *)&argc, argv);
+
+    /* copy argv/argc because XtOpenDisplay consumes arguments we may need
+       for the server command line */
+    xt_argv = (char**)XtMalloc(sizeof(char*) * (argc + 1));
+    memcpy(xt_argv, argv, sizeof(char*) * (argc + 1));
+    xt_argc = argc;
     
-    /* Process the command line before calling XtOpenDisplay, because the
-       latter consumes certain command line arguments that we still need
-       (-icon, -geometry ...) */
-    commandLine = processCommandLine(argc, argv);
-        
     /* Open the display and find the root window */
     TheDisplay = XtOpenDisplay (context, NULL, APP_NAME, APP_CLASS, NULL,
-    	    0, &argc, argv);
+            0, &xt_argc, xt_argv);
     if (!TheDisplay) {
 	XtWarning ("nc: Can't open display\n");
 	exit(EXIT_FAILURE);
     }
+    XtFree((char*)xt_argv);
     rootWindow = RootWindow(TheDisplay, DefaultScreen(TheDisplay));
     
+    /* Process the command line, with original arguments */
+    commandLine = processCommandLine(argc, argv);
+
     /* Read the application resources into the Preferences data structure */
     RestorePreferences(prefDB, XtDatabase(TheDisplay), APP_NAME,
     	    APP_CLASS, PrefDescrip, XtNumber(PrefDescrip));
@@ -503,7 +511,8 @@ static int startServer(const char *messa
     
     /* prompt user whether to start server */
     if (!Preferences.autoStart) {
-	printf(message);
+        printf("%s", message);
+        fflush(stdout);
 	do {
     	    c = getc(stdin);
 	} while (c == ' ' || c == '\t');
@@ -605,19 +614,34 @@ static CommandLine processCommandLine(in
 */
 static void parseCommandLine(int argc, char **argv, CommandLine *commandLine)
 {
-#define MAX_RECORD_HEADER_LENGTH 38
+#define MAX_RECORD_HEADER_LENGTH 64
     char name[MAXPATHLEN], path[MAXPATHLEN];
     const char *toDoCommand = "", *langMode = "", *geometry = "";
     char *commandString, *outPtr;
     int lineNum = 0, read = 0, create = 0, iconic = 0, tabbed = -1, length = 0;
     int i, lineArg, nRead, charsWritten, opts = True;
     int fileCount = 0, group = 0, isTabbed;
+    int doInNew = False;
+
+    char *filePrefix = "";
+    long filePrefixLen = 0;
+#ifndef VMS
+    if (strcmp(GetNameOfHost(LOCAL_NAME), GetNameOfHost(NEDIT_NAME)))
+    {
+        filePrefixLen = strlen(GetNameOfHost(LOCAL_NAME)) + 1
+                + strlen(GetUserName(LOCAL_NAME)) + 1;
+        filePrefix = XtMalloc(filePrefixLen + 1);
+        sprintf(filePrefix, "%s@%s:",
+                GetUserName(LOCAL_NAME), GetNameOfHost(LOCAL_NAME));
+    }
+#endif
 
     /* Allocate a string for output, for the maximum possible length.  The
        maximum length is calculated by assuming every argument is a file,
        and a complete record of maximum length is created for it */
     for (i=1; i<argc; i++) {
-    	length += MAX_RECORD_HEADER_LENGTH + strlen(argv[i]) + MAXPATHLEN;
+        length += MAX_RECORD_HEADER_LENGTH + strlen(argv[i]) + MAXPATHLEN
+                + filePrefixLen;
     }
     /* In case of no arguments, must still allocate space for one record header */
     if (length < MAX_RECORD_HEADER_LENGTH)
@@ -635,6 +659,10 @@ static void parseCommandLine(int argc, c
 	} else if (opts && !strcmp(argv[i], "-do")) {
     	    nextArg(argc, argv, &i);
     	    toDoCommand = argv[i];
+        } else if (opts && !strcmp(argv[i], "-do-in-new")) {
+            nextArg(argc, argv, &i);
+            toDoCommand = argv[i];
+            doInNew = True;
     	} else if (opts && !strcmp(argv[i], "-lm")) {
 	    copyCommandLineArg(commandLine, argv[i]);
     	    nextArg(argc, argv, &i);
@@ -735,16 +763,19 @@ static void parseCommandLine(int argc, c
 		}
 	    
                 /* See below for casts */
-    		sprintf(outPtr, "%d %d %d %d %d %ld %ld %ld %ld\n%s\n%s\n%s\n%s\n%n",
-			lineNum, read, create, iconic, tabbed, (long) strlen(path),
+                sprintf(outPtr, "%d %d %d %d %d %ld %ld %ld %ld\n"
+                                "%s%s\n%s\n%s\n%s\n%n",
+                        lineNum, read, create, iconic, tabbed,
+                        filePrefixLen + (long) strlen(path),
 			(long) strlen(toDoCommand), (long) strlen(langMode), 
                         (long) strlen(geometry),
-			path, toDoCommand, langMode, geometry, &charsWritten);
+                        filePrefix, path, toDoCommand, langMode, geometry,
+                        &charsWritten);
 		outPtr += charsWritten;
 		free(nameList[j]);
 
                 /* Create the file open atoms for the paths supplied */
-                addToFileList(path);
+                addToFileList(filePrefixLen, filePrefix, path);
 	        fileCount++;
 	    }
 	    if (nameList != NULL)
@@ -778,10 +809,13 @@ static void parseCommandLine(int argc, c
                is 64 bit on Alphas, and 32-bit on most others.  There is
                no printf format specifier for "size_t", thanx, ANSI. */
     	    sprintf(outPtr, "%d %d %d %d %d %ld %ld %ld %ld\n%n", lineNum,
-		    read, create, iconic, isTabbed, (long) strlen(path), 
+                    read, create, iconic, isTabbed,
+                    filePrefixLen + (long) strlen(path),
 		    (long) strlen(toDoCommand), (long) strlen(langMode),
 		    (long) strlen(geometry), &charsWritten);
     	    outPtr += charsWritten;
+            strcpy(outPtr, filePrefix);
+            outPtr += filePrefixLen;
     	    strcpy(outPtr, path);
     	    outPtr += strlen(path);
     	    *outPtr++ = '\n';
@@ -797,9 +831,10 @@ static void parseCommandLine(int argc, c
 	    toDoCommand = "";
 
             /* Create the file open atoms for the paths supplied */
-            addToFileList(path);
+            addToFileList(filePrefixLen, filePrefix, path);
 	    fileCount++;
 #endif /* VMS */
+            doInNew = False;
     	}
     }
 #ifdef VMS
@@ -812,10 +847,42 @@ static void parseCommandLine(int argc, c
      * iconic state (and optional language mode and geometry).
      */
     if (toDoCommand[0] != '\0' || fileCount == 0) {
-	sprintf(outPtr, "0 0 0 %d %d 0 %ld %ld %ld\n\n%n", iconic, tabbed,
-		(long) strlen(toDoCommand),
-		(long) strlen(langMode), (long) strlen(geometry), &charsWritten);
+        char current[MAXPATHLEN];
+        long length;
+        strcpy(current, GetCurrentDir());
+        length = strlen(current);
+
+#ifndef VMS
+        /* do we have a "/" at the end? if not, add one */
+        if (0 < length && current[length - 1] != '/' && length < MAXPATHLEN - 1) {
+            strcpy(&current[length], "/");
+            length++;
+        }
+#else /* VMS */
+        /* A logical name should be followed by a colon so that the filename can
+           be added to it to make a full file specification; otherwise a directory
+           path had the form
+             device_or_logicalname:[dir.dir.dir]
+           this requires no separator before the file name.
+         */
+        if (0 < length && strchr(":]", current[length - 1]) == NULL) {
+            strcpy(&current[length], ":"); /* could not find a separator at end */
+            length++;
+        }
+        /* TODO: is this enough for VMS? what of posix emulation? */
+        /* TODO: what about other platforms? */
+#endif /* VMS */
+
+        sprintf(outPtr, "0 0 %d %d %d %ld %ld %ld %ld\n%n",
+                doInNew, iconic, tabbed, -(filePrefixLen + length),
+                (long) strlen(toDoCommand), (long) strlen(langMode),
+                (long) strlen(geometry), &charsWritten);
 	outPtr += charsWritten;
+        strcpy(outPtr, filePrefix);
+        outPtr += filePrefixLen;
+        strcpy(outPtr, current);
+        outPtr += length;
+        *outPtr++ = '\n';
 	strcpy(outPtr, toDoCommand);
 	outPtr += strlen(toDoCommand);
 	*outPtr++ = '\n';
@@ -826,6 +893,9 @@ static void parseCommandLine(int argc, c
 	outPtr += strlen(geometry);
 	*outPtr++ = '\n';
     }
+
+    if (filePrefixLen > 0)
+        XtFree(filePrefix);
     
     *outPtr = '\0';
     commandLine->serverRequest = commandString;
diff --quilt old/source/server.c new/source/server.c
--- old/source/server.c
+++ new/source/server.c
@@ -381,10 +381,12 @@ static void processServerCommandString(c
 	if (itemsRead != 9)
     	    goto readError;
 	inPtr += charsRead + 1;
-	if (inPtr - string + fileLen > stringLen)
+        if (fileLen >= 0 && inPtr - string + fileLen > stringLen)
+            goto readError;
+        if (fileLen < 0 && inPtr - string - fileLen > stringLen)
 	    goto readError;
 	requestname = inPtr;
-	inPtr += fileLen;
+        inPtr += fileLen < 0 ? -fileLen : fileLen;
 	*inPtr++ = '\0';
 	if (inPtr - string + doLen > stringLen)
 	    goto readError;
@@ -411,13 +413,16 @@ static void processServerCommandString(c
 	if (fileLen <= 0) {
     	    for (window=WindowList; window!=NULL; window=window->next)
     		if (!window->filenameSet && !window->fileChanged &&
-                    isLocatedOnDesktop(window, currentDesktop))
+                    isLocatedOnDesktop(window, currentDesktop) &&
+                    (fileLen < 0 ? !strcmp(window->path, fullname) : True))
     	    	    break;
 
-    	    if (*doCommand == '\0') {
+            if (*doCommand == '\0' || createFlag) {
                 if (window == NULL) {
-    		    EditNewFile(findWindowOnDesktop(tabbed, currentDesktop), 
-                                NULL, iconicFlag, lmLen==0?NULL:langMode, NULL,
+                    window = EditNewFile(findWindowOnDesktop(tabbed,
+                                                currentDesktop),
+                                NULL, iconicFlag, lmLen==0?NULL:langMode,
+                                fileLen < 0 ? fullname : NULL,
                                 False);
     	        } else {
 	            if (iconicFlag)
@@ -425,23 +430,28 @@ static void processServerCommandString(c
 		    else
 		    	RaiseDocumentWindow(window);
 	        }
+
+                if (window && *doCommand != '\0')
+                    DoMacro(window, doCommand, "-do-in-new macro");
             } else {
-                WindowInfo *win = WindowList;
-		/* Starting a new command while another one is still running
-		   in the same window is not possible (crashes). */
-		while (win != NULL && win->macroCmdData != NULL) {
-		    win = win->next;
-		}
+                if (window == NULL || window->macroCmdData != NULL) {
+                    /* Starting a new command while another one is still running
+                       in the same window is not possible (crashes). */
+                    window = WindowList;
+                    while (window != NULL && window->macroCmdData != NULL) {
+                        window = window->next;
+                    }
+                }
 		
-		if (!win) {
+                if (!window) {
 		    XBell(TheDisplay, 0);
 		} else {
 		    /* Raise before -do (macro could close window). */
 	            if (iconicFlag)
-		    	RaiseDocument(win);
+                        RaiseDocument(window);
 		    else
-		    	RaiseDocumentWindow(win);
-		    DoMacro(win, doCommand, "-do macro");
+                        RaiseDocumentWindow(window);
+                    DoMacro(window, doCommand, "-do macro");
 		}
 	    }
 	    CheckCloseDim();
diff --quilt old/util/utils.c new/util/utils.c
--- old/util/utils.c
+++ new/util/utils.c
@@ -119,38 +119,60 @@ const char* GetHomeDir(void)
 ** allocated string.
 */
 const char
-*GetUserName(void)
+*GetUserName(enum nameType name)
 {
+    static char userName[2][MAXUSERNAMELEN+1];
+    static int userNameFound = False;
+
+    if (!userNameFound) {
+        const char *user;
+
 #ifdef VMS
-    return cuserid(NULL);
+        user = cuserid(NULL);
 #else
-    /* cuserid has apparently been dropped from the ansi C standard, and if
-       strict ansi compliance is turned on (on Sun anyhow, maybe others), calls
-       to cuserid fail to compile.  Older versions of nedit try to use the
-       getlogin call first, then if that fails, use getpwuid and getuid.  This
-       results in the user-name of the original terminal being used, which is
-       not correct when the user uses the su command.  Now, getpwuid only: */
 
-    const struct passwd *passwdEntry;
-    static char *userName=NULL;
-    
-    if (userName)
-       return userName;
-    
-    passwdEntry = getpwuid(getuid());
-    if (!passwdEntry) {
-       /* This is really serious, but sometimes username service
-          is misconfigured through no fault of the user.  Be nice
-          and let the user start nc anyway. */
-       perror("nedit: getpwuid() failed - reverting to $USER");
-       return getenv("USER");
-    }
-    else {
-       userName=malloc(strlen(passwdEntry->pw_name)+1);
-       strcpy(userName, passwdEntry->pw_name);
-       return userName;
-    }
+        /* cuserid has apparently been dropped from the ansi C standard,
+           and if strict ansi compliance is turned on (on Sun anyhow,
+           maybe others), calls to cuserid fail to compile.  Older
+           versions of nedit try to use the getlogin call first, then if
+           that fails, use getpwuid and getuid.  This results in the
+           user-name of the original terminal being used, which is not
+           correct when the user uses the su command.  Now, getpwuid only: */
+
+        const struct passwd *passwdEntry = getpwuid(getuid());
+        if (!passwdEntry || !passwdEntry->pw_name) {
+            /* This is really serious, but sometimes username service
+               is misconfigured through no fault of the user.  Be nice
+               and let the user start nc anyway. */
+            perror("nedit: getpwuid() failed - reverting to $USER");
+            user = getenv("USER");
+        }
+        else {
+            user = passwdEntry->pw_name;
+        }
 #endif /* VMS */
+
+        if (!user) {
+            fprintf(stderr, "nedit: failed to determine user name.");
+            exit(EXIT_FAILURE);
+        }
+        if (strlen(user) > MAXUSERNAMELEN)
+            fprintf(stderr, "nedit: Username to long, need to truncate.\n");
+        strncpy(userName[LOCAL_NAME], user, MAXUSERNAMELEN);
+        userName[LOCAL_NAME][MAXUSERNAMELEN] = '\0';
+
+        /* set nedit user to $NEDIT_USER,
+           but only if it fits into the buffer */
+        if ((user = getenv("NEDIT_USER")) && (strlen(user) <= MAXUSERNAMELEN)) {
+            strcpy(userName[NEDIT_NAME], user);
+        } else {
+            strcpy(userName[NEDIT_NAME], userName[LOCAL_NAME]);
+        }
+
+        userNameFound = True;
+    }
+
+    return userName[name];
 }
 
 
@@ -162,12 +184,13 @@ const char
 ** VMS links case-insensitively.
 */
 const char
-*GetNameOfHost(void)
+*GetNameOfHost(enum nameType name)
 {
-    static char hostname[MAXNODENAMELEN+1];
+    static char hostname[2][MAXNODENAMELEN+1];
     static int  hostnameFound = False;
     
     if (!hostnameFound) {
+        const char *host;
 #ifdef VMS
         /* This should be simple, but uname is not supported in the DEC C RTL and
            gethostname on VMS depends either on Multinet or UCX.  So use uname 
@@ -179,12 +202,12 @@ const char
         unsigned long int unused = 0;
         unsigned short int hostnameLen = MAXNODENAMELEN+1;
 
-        hostnameDesc = NulStrWrtDesc(hostname, MAXNODENAMELEN+1);
+        hostnameDesc = NulStrWrtDesc(hostname[LOCAL_NAME], MAXNODENAMELEN+1);
         syi_status = lib$getsyi(&syiItemCode, &unused, hostnameDesc, &hostnameLen,
     			        0, 0);
         if (syi_status != SS$_NORMAL) {
 	    fprintf(stderr, "nedit: Error return from lib$getsyi: %d", syi_status);
-	    strcpy(hostname, "VMS");
+	    strcpy(hostname[LOCAL_NAME], "VMS");
         } else
     	    hostname[hostnameLen] = '\0';
         FreeStrDesc(hostnameDesc);
@@ -196,11 +219,23 @@ const char
            perror("nedit: uname() failed ");
            exit(EXIT_FAILURE);
         }
-        strcpy(hostname, nameStruct.nodename);
+        if (strlen(nameStruct.nodename) > MAXNODENAMELEN)
+            fprintf(stderr, "nedit: hostname to long, need to truncate.\n");
+        strcpy(hostname[LOCAL_NAME], nameStruct.nodename);
+        hostname[LOCAL_NAME][MAXNODENAMELEN] = '\0';
 #endif /* VMS */
+
+        /* set remote hostname to $NEDIT_HOST,
+           but only if it fits into the buffer */
+        if ((host = getenv("NEDIT_HOST")) && (strlen(host) <= MAXNODENAMELEN)) {
+            strcpy(hostname[NEDIT_NAME], host);
+        } else {
+            strcpy(hostname[NEDIT_NAME], hostname[LOCAL_NAME]);
+        }
+
         hostnameFound = True;
     }
-    return hostname;
+    return hostname[name];
 }
 
 
diff --quilt old/source/server_common.c new/source/server_common.c
--- old/source/server_common.c
+++ new/source/server_common.c
@@ -64,8 +64,8 @@ void CreateServerPropertyAtoms(const cha
                   MAXNODENAMELEN+1+
                   MAXUSERNAMELEN+1+
                   MAXSERVERNAMELEN+1];
-    const char *userName = GetUserName();
-    const char *hostName = GetNameOfHost();
+    const char *userName = GetUserName(NEDIT_NAME);
+    const char *hostName = GetNameOfHost(NEDIT_NAME);
 
     sprintf(propName, "NEDIT_%s_SERVER_EXISTS_%s_%s_%s",
             NEDIT_VERSION_STRING, hostName, userName, serverName);
@@ -102,8 +102,8 @@ Atom CreateServerFileOpenAtom(const char
                   MAXSERVERNAMELEN+1+
                   MAXPATHLEN+1+
                   7+1];
-    const char *userName = GetUserName();
-    const char *hostName = GetNameOfHost();
+    const char *userName = GetUserName(NEDIT_NAME);
+    const char *hostName = GetNameOfHost(NEDIT_NAME);
     Atom        atom;
 
     sprintf(propName, "NEDIT_%s_FILE_%s_%s_%s_%s_WF_OPEN",
@@ -123,8 +123,8 @@ Atom CreateServerFileClosedAtom(const ch
                   MAXSERVERNAMELEN+1+
                   MAXPATHLEN+1+
                   9+1];
-    const char *userName = GetUserName();
-    const char *hostName = GetNameOfHost();
+    const char *userName = GetUserName(NEDIT_NAME);
+    const char *hostName = GetNameOfHost(NEDIT_NAME);
     Atom        atom;
 
     sprintf(propName, "NEDIT_%s_FILE_%s_%s_%s_%s_WF_CLOSED",
@@ -145,8 +145,8 @@ void DeleteServerFileAtoms(const char* s
                         MAXUSERNAMELEN+1+
                         MAXSERVERNAMELEN+1+
                         1];
-    const char *userName = GetUserName();
-    const char *hostName = GetNameOfHost();
+    const char *userName = GetUserName(NEDIT_NAME);
+    const char *hostName = GetNameOfHost(NEDIT_NAME);
     int length = sprintf(propNamePrefix, "NEDIT_%s_FILE_%s_%s_%s_",
             NEDIT_VERSION_STRING, hostName, userName, serverName);
 
diff --quilt old/util/utils.h new/util/utils.h
--- old/util/utils.h
+++ new/util/utils.h
@@ -37,11 +37,13 @@
 #include <sys/param.h>
 #endif /*VMS*/
 
+enum nameType {LOCAL_NAME, NEDIT_NAME};
+
 const char *GetCurrentDir(void);
 const char *GetHomeDir(void);
 char *PrependHome(const char *filename, char *buf, size_t buflen);
-const char *GetUserName(void);
-const char *GetNameOfHost(void);
+const char *GetUserName(enum nameType name);
+const char *GetNameOfHost(enum nameType name);
 int Min(int i1, int i2);
 const char* GetRCFileName(int type);
 const char* GetNEditHome(void);
diff --quilt old/source/windowTitle.c new/source/windowTitle.c
--- old/source/windowTitle.c
+++ new/source/windowTitle.c
@@ -352,7 +352,7 @@ char *FormatWindowTitle(const char* file
                         }
                     } else if (*titleFormat == 'h') {
                         int comps = c - '0';
-                        char* hostname = strdup(GetNameOfHost());
+                        char* hostname = strdup(GetNameOfHost(NEDIT_NAME));
                         char *p, *n;
                         hostNamePresent = True;
                         titleFormat++; /* delete the argument */
@@ -380,7 +380,8 @@ char *FormatWindowTitle(const char* file
                     
                 case 'h': /* host name */
 		    hostNamePresent = True;
-		    titlePtr = safeStrCpy(titlePtr, titleEnd, GetNameOfHost());
+                    titlePtr = safeStrCpy(titlePtr, titleEnd,
+                            GetNameOfHost(NEDIT_NAME));
                     break;
 		    
                 case 'S': /* file status */
@@ -401,7 +402,8 @@ char *FormatWindowTitle(const char* file
                     
                 case 'u': /* user name */
 		    userNamePresent = True;
-                    titlePtr = safeStrCpy(titlePtr, titleEnd, GetUserName());
+                    titlePtr = safeStrCpy(titlePtr, titleEnd,
+                            GetUserName(NEDIT_NAME));
                     break;
                    
                 case '%': /* escaped % */
